<?php
/**
 * pragmaMx  Content Management System
 * Copyright (c) 2006 pragmaMx Dev Team - http://pragmaMx.org
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * $Source: /home/www/dps3311/home/cvsroot/pragmamx/pragmamx_01/modules/Private_Messages/buddy.php,v $
 * $Revision: 1.17 $
 * $Author: tora60 $
 * $Date: 2007/04/05 11:21:43 $
 * 
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Part of phpBB integration
 * Copyright (c) 2001 by
 * Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 */
if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");
$GLOBALS["module_name"] = basename(dirname(__FILE__));
$ThemeSel = mxGetTheme();
require_once("themes/$ThemeSel/theme.php");
// ################ Einstell Variablen ############################################################################
$GLOBALS["buddylistrefresh"] = 30000; # Refresh Wenn Buddy alleine laeuft
$GLOBALS["buddycheckpm"] = 6000; # Refresh Wenn Buddy alleine laeuft
$GLOBALS["showAdminPrefix"] = "*"; # kleiner Zusatztext hinter dem Adminnamen (funktioniert nur wenn selfAdmin installiert ist)
// User, die nicht angezeigt werden sollen
// Namen mit Komma trennen!
$GLOBALS["excludedusers"] = "Texster, Knaxller";
$GLOBALS['b_bodycolor'] = $bgcolor1; # Hintergrundfarbe des Messangers, kann auch direkt ein HTML-Farbwert sein z.B. #999999
$GLOBALS['b_textcolor'] = $textcolor1; # Textfarben des Messangers, kann auch direkt ein HTML-Farbwert sein z.B. #999999
// #################################################################################################################
// Link verwendet in Sprachdateien
if (!defined("_PMSBBCODELINK")) define("_PMSBBCODELINK", "<a href=\"#\" onClick=\"window.open('modules.php?name=" . $module_name . "&file=bbcode','pmbbcode','left=10, top=10, width=640,height=480,toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,copyhistory=0'); return false;\">");

include_once("modules/" . $GLOBALS["module_name"] . "/config.php");
if (@file_exists('modules/' . $module_name . '/bbfunctions.php')) include_once("modules/" . $module_name . "/bbfunctions.php");
include_once("modules/" . $GLOBALS["module_name"] . "/functions.php");
mxGetLangfile($GLOBALS["module_name"]);

$GLOBALS["userinfo"] = array();
$totalmembers = 0;

if (!MX_IS_USER) {
    notloggedin();
    exit;
} 

$GLOBALS["userinfo"] = mxGetUserData();
// if(!mxModuleAllowed($GLOBALS["module_name"])) {
// notallowed();
// exit;
// }
// SQL-bedingung fuer excluded Users erstellen
$exusers = explode (",", $GLOBALS["excludedusers"]);
if (!MX_IS_ADMIN) {
    while (list($key, $val) = each($exusers)) {
        $xexusers[] = trim($val);
    } 
} 
$xexusers[] = $GLOBALS['anonymous'];
$GLOBALS["excludedusers"] = "'" . implode("','", mxAddSlashesForSQL($xexusers)) . "'";
// ##############################################
function create_headerforall($pagetitle)
{
    global $bgcolor2, $textcolor2, $ThemeSel;
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html>\n<head>\n";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . _CHARSET . "\">\n";
    echo "<meta http-equiv=\"content-language\" content=\"" . _DOC_LANGUAGE . "\">\n";
    echo "<meta http-equiv=\"Page-Enter\" content=\"revealTrans(Duration=0.1,Transition=23)\">\n";
    echo "<meta http-equiv=\"expires\" content=\"0\">\n";
    echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
    echo "<title>" . $pagetitle . "</title>\n";
    echo "<link rel=\"StyleSheet\" href=\"themes/$ThemeSel/style/style.css\" type=\"text/css\">\n";
    if (@file_exists("themes/$ThemeSel/style/style.php")) {
        echo "<link rel=\"StyleSheet\" href=\"themes/$ThemeSel/style/style.php\" type=\"text/css\">\n";
    } 
} 
// ##############################################
function create_bodyforall($extensions = "") // schliesst <head> und oeffnet <body>
{
    global $b_bodycolor, $b_textcolor;
    echo "\n</head>\n<body bgcolor='$b_bodycolor' text='$b_textcolor' link='$b_textcolor' style='background-color: $b_bodycolor; color: $b_textcolor; margin: 0;'>\n";
} 
// ##############################################
function pmSetOnline() // schliesst <head> und oeffnet <body>
{
    global $prefix, $user_prefix;
    $last = mxSessionGetVar("lasttime"); // Zurcksetzen, damit Online ausgefhrt wird
    $past = time() - MX_SETINACTIVE_MINS ; 
    // $GLOBALS["mxSqlDebug"]      = 1;
    if ($last <= $past) {
        if ($GLOBALS["dbtype"] == "MySQL") sql_query("LOCK TABLES ${user_prefix}_users WRITE");
        $qry = "UPDATE ${user_prefix}_users set user_lastvisit=" . time() . " where uname='" . mxAddSlashesForSQL($GLOBALS['userinfo']['uname']) . "'";
        $result = sql_query($qry);
        if ($GLOBALS["dbtype"] == "MySQL") sql_query("UNLOCK TABLES");
        mxSessionSetVar("lasttime", time());
    } 
} 
// ##############################################
function get_userslist($mode)
{
    global $prefix, $user_prefix;
    if ($mode == "all") {
        $qry = "SELECT DISTINCT a.aid, u.uname
FROM ${user_prefix}_users AS u 
LEFT JOIN ${prefix}_authors AS a 
ON u.uid = a.user_uid 
WHERE u.uname Not In (" . $GLOBALS["excludedusers"] . ") AND u.user_stat=1;";
    } else {
        pmSetOnline();
        $past = time() - MX_SETINACTIVE_MINS ;
        $qry = "SELECT DISTINCTROW a.aid, u.uname
FROM ${user_prefix}_users AS u 
LEFT JOIN ${prefix}_authors AS a 
ON u.uid = a.user_uid
WHERE (((u.uname) Not In (" . $GLOBALS["excludedusers"] . ") 
And (u.uname) Is Not Null) 
AND (u.user_stat=1) 
AND (u.user_lastvisit >= " . $past . ")
AND (u.user_lastmod<>'logout'));";
    } 
    $result = sql_query($qry);
    while (list($adminname, $uname) = sql_fetch_row($result)) {
        $showname = (empty($adminname)) ? $uname : " " . $adminname . " " . $GLOBALS["showAdminPrefix"] . "";
        $showname = mxCutString($showname, 20, "..", ""); # Kurzen Usernamen erstellen
        $out[ucfirst($showname) . "&nbsp;"] = $uname;
    } 
    if (isset($out)) {
        ksort($out);
        return $out;
    } else {
        return array();
    } 
} 
// ##############################################
function create_footerforall()
{
    echo "</body>\n</html>";
} 
// ##############################################
function compose($to, $subject, $to_userid = 0)
{
    include("modules/" . $GLOBALS['module_name'] . "/inboxsize-conf.php");
    global $bgcolor1, $bgcolor2, $textcolor1, $textcolor2, $prefix, $user_prefix, $pmgrenze_godadmin, $pmgrenze_admin;
    $selectfield = "subject";
    if (empty($to_userid)) {
        $res = sql_query("SELECT uid, uname FROM ${user_prefix}_users WHERE uname='" . mxAddSlashesForSQL($to) . "'");
        list($to_userid, $to_user) = sql_fetch_row($res);
    } 
    if ($subject) {
        $subject = mxStripSlashes($subject);
        $subject = msg_desmile($subject);
        $subject = str_replace("" . _PMSRE . ": " . _PMSRE . ": ", _PMSRE . ": ", $subject);
        $selectfield = "msg_text";
    } 
    $extensions = " onload=\"document.pmsubmit." . $selectfield . ".focus(); document.pmsubmit." . $selectfield . ".select();\"";
    create_headerforall(_PMSTITLE);
    create_bodyforall($extensions);
// PM Begrenzung
$result_anzahl = sql_query("SELECT Count(*) FROM " . $prefix . "_priv_msgs WHERE to_userid=$to_userid");
$qry_sent = "SELECT Count(*) FROM " . $prefix . "_priv_msgs_send WHERE from_userid=" . $GLOBALS["userinfo"]["uid"] . "";
$result_sent = sql_query($qry_sent);
$count_anzahl = sql_fetch_row($result_anzahl);
$countpmsent = sql_fetch_row($result_sent);
if (MX_IS_ADMIN && $pmgrenze_admin == 0) {
} else {
	if (mxGetAdminPref('radminsuper') && $pmgrenze_godadmin == 0) {
	} else {
		if ($sentboxsize == 0) {
		} else {
			if ($countpmsent[0] >= $sentboxsize) {
    			echo "<br>\n<b><br><center>" . _SENTPMBOXVOLL . "</b><br>\n<br><br></center>\n\n";
    			create_footerforall();
    			die("");
			}
		}
		if ($inboxsize == 0) {
		} else {
			if ($count_anzahl[0] >= $inboxsize) {
    			echo "<br>\n<b><br><center>" . _PMBOXVOLL."</b><br>\n<br><br></center>\n\n";
    			create_footerforall();
    			die("");
			}
		}
	}
}
//Ende PM Begrenzung
    echo "
<form action=\"modules.php?name=" . $GLOBALS['module_name'] . "\" method=\"POST\" target=\"_self\" name=\"pmsubmit\">
<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"$bgcolor1\" style=\"height: 100%;\"><tr><td align=\"center\">
" . _PMSSENDM . "<b> $to</b><br>\n<br>
<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" bgcolor=\"$bgcolor2\">
<tr><td valign=\"top\"><b>" . _PMSSUBJECT . "</b></td>\n<td>\n<input type=\"text\" name=\"subject\" size=\"45\" maxlength=\"50\" value=\"" . mxEntityQuotes($subject) . "\" style=\"border: 1px solid; background-color: $bgcolor1; font-family: sans-serif; font-size: 10px;\"></td>\n</tr>
<tr><td valign=\"top\"><b>" . _PMSMESSAGE . "</b></td>\n<td>\n<textarea name=\"message\" cols=\"44\" rows=\"4\" style=\"border: 1px solid; background-color: $bgcolor1; font-family: sans-serif; font-size: 10px;\"></textarea></td></tr>
";
    if ($GLOBALS['smilies_in_buddy']) {
        echo '<tr><td><script language="JavaScript" src="modules/' . $GLOBALS['module_name'] . '/javascript.js" type="text/javascript"></script></td><td>' . printbuddysmilies() . '</td></tr>';
    }
    echo "
</table>\n
" . _PMSSAVE . "<input type='checkbox' checked name='notsave' value='1' style='background-color: transparent;'>
<br>\n<center>
<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS["module_name"] . "\">	
<input type=\"hidden\" name=\"file\" value=\"buddy\">	
<input type=\"hidden\" name=\"to_userid\" value=\"" . $to_userid . "\">	
<input type=\"hidden\" name=\"op\" value=\"send\">
<input type=\"hidden\" name=\"to\" value=\"" . mxEntityQuotes($to_user) . "\">
<input type=\"image\" src=\"" . $GLOBALS["url_button"] . "/senden.gif\" style=\"background-color: transparent; border: none;\">
<a href=\"javascript:window.close()\" onClick=\"window.close()\"><img src=\"" . $GLOBALS["url_button"] . "/abbrechen.gif\" border=\"0\"  style=\"background-color: transparent;\"></a>
</center>
</td>\n</tr>\n</table>\n</form>\n";
    create_footerforall();
} 
// ##############################################
function sendm($to, $to_userid, $msg_text, $subject)
{
    global $bgcolor1, $bgcolor2, $textcolor1, $textcolor2, $prefix, $user_prefix, $notsave;
    $subject = strip_tags($subject);
    if (!$subject) $subject = _PMSFROM . " " . $GLOBALS["userinfo"]["uname"] . "";
    $subject = mxAddSlashesForSQL($subject);
    $msg_text = mxAddSlashesForSQL($msg_text);
    $sql = "INSERT INTO ${prefix}_priv_msgs (msg_image, subject, from_userid, to_userid, msg_time, msg_text) ";
	$sql_msg_sent = "INSERT INTO ${prefix}_priv_msgs_send (msg_image, subject, from_userid, to_userid, msg_time, msg_text) ";
    $sql .= "VALUES ('" . $GLOBALS["subjectdefaulticon"] . "', '$subject', '" . $GLOBALS["userinfo"]["uid"] . "', '$to_userid', now(), '$msg_text')";
	$sql_msg_sent .= "VALUES ('" . $GLOBALS["subjectdefaulticon"] . "', '$subject', '$to_userid', '" . $GLOBALS["userinfo"]["uid"] . "', now(), '$msg_text')";
//ignore Funktion
if (mxModuleAllowed("Friendlist")) {
    include("modules/Friendlist/config.php");
	if (!(MX_IS_ADMIN && $friendlist_admin == 0)) {
		if (!(mxGetAdminPref('radminsuper') && $friendlist_godadmin == 0)) {
$ignore = sql_query("select uname from " . $prefix . "_users_ignorelist where uid='" . $to_userid . "' AND ignoreid='" . $GLOBALS["userinfo"]["uid"] . "'");
$nene = sql_num_rows($ignore);
list($ignorename) = sql_fetch_row($ignore);
			if ($nene == 1) {
create_headerforall(_PMSTITLE);
create_bodyforall();
echo "<br><center>" . $ignorename . " " . _NOMESSAGE . "<br />"
	. "</TR></table>";
echo "<a href=\"javascript:window.close()\" onClick='window.close()'><img src=\"" . $GLOBALS["url_button"] . "/schliessen.gif\" border=0  style=\"background-color: transparent;\"></a><br>\n<br>\n\n";
	create_footerforall();
	die;
			}
		}
	}
}
####
###Email bei neuer PN wenn User offline ist #####
$Absender = $GLOBALS["userinfo"]["uname"];
list($touser_uname,$touser_email,$user_pm_mail) = sql_fetch_row(sql_query("SELECT uname, email, user_pm_mail FROM " . $user_prefix . "_users WHERE uid='$to_userid'"));
$message = _HELLO . " $touser_uname,\n" . _PMEMAIL . MX_BASE_URL . _PMEMAIL1 . "$Absender " . _PMEMAIL2 . MX_BASE_URL . "/modules.php?name=" . $GLOBALS['module_name'] . _PMEMAIL3 . MX_BASE_URL . "/modules.php?name=Your_Account&op=edithome";
$subject = _PMEMAILSUB . MX_BASE_URL;
if (!mxIsUserOnline($touser_uname) && ($user_pm_mail ==1))
{
   mxMail($touser_email, "$subject", $message, $GLOBALS['adminmail'],"text","PM-Mail");
}
#######
    if ($to_userid && $msg_text) {
        $result = sql_query($sql);
		if ($notsave) { sql_query($sql_msg_sent); }
    } 
    if (empty($result)) {
        $msg = "<br>\n<b><br>" . _PMSBUDDYERROR . "</b><br>\n<br>\n\n";
        $timeout = 15000;
    } else {
        $msg = "<br>\n<br>\n<b>" . _PMSSENDED1 . " $to " . _PMSSENDED2 . "</b><br>\n<br>\n\n";
        $timeout = 1000;
    } 
    create_headerforall(_PMSTITLE);
    create_bodyforall();
    echo "<br>\n<br>\n";
    echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"$bgcolor1\"><tr><td align=\"center\">\n";
    echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" bgcolor=\"$bgcolor2\">\n";
    echo "<tr><td align=\"center\">\n$msg";
    echo "<a href=\"javascript:window.close()\" onClick='window.close()'><img src=\"" . $GLOBALS["url_button"] . "/schliessen.gif\" border=0  style=\"background-color: transparent;\"></a><br>\n<br>\n\n";
    echo "<font class=\"tiny\">" . _PMSAUTOCLOSE . "</font><br>\n<br>\n\n";
    echo "<script language=\"JavaScript\" type=\"text/javascript\">\n";
    echo "		<!--\n";
    echo "		setTimeout(\"self.close()\", $timeout);\n";
    echo "		// -->\n";
    echo "	</script>";
    echo "</td>\n</tr>\n</table>\n</td>\n</tr>\n</table>\n";
    create_footerforall();
}
// ##############################################
function readm($msg_id)
{
    global $bgcolor1, $bgcolor2, $textcolor1, $textcolor2, $prefix, $user_prefix;
    $msg_id = (int)$msg_id;
    setlocale(LC_TIME, $GLOBALS["locale"]);
    $qry = "SELECT p.*, UNIX_TIMESTAMP(p.msg_time) as msgtimestamp , u.uname, u.user_avatar 
            FROM ${prefix}_priv_msgs AS p 
            LEFT JOIN ${user_prefix}_users AS u 
            ON p.from_userid = u.uid 
            WHERE (msg_id=$msg_id) 
            AND (to_userid=" . intval($GLOBALS["userinfo"]["uid"]) . ") 
            ";
    $result = sql_query($qry);
    $row = sql_fetch_array($result);
    if (empty($row["msg_id"])) { // falls Nachricht in Zwischenzeit geloescht..
        closewindow();
    } else {
        $delcheck = (MX_IS_ADMIN) ? "" : " checked";

        $replysubject = msg_desmile($row["subject"]);
        $row["subject"] = strip_tags($row["subject"]);
        $row["subject"] = msg_smile($row["subject"]);

        $row["msg_text"] = pmPrepDisplay($row["msg_text"]);

        $row["msgtimestamp"] = mx_strftime(_PMSTIMESTRING, $row["msgtimestamp"]);
        sql_query("UPDATE ${prefix}_priv_msgs SET read_msg='1' WHERE msg_id='" . $row["msg_id"] . "'");
        create_headerforall(_PMSTITLE);
        create_bodyforall();
        echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"$bgcolor1\" style=\"height: 100%;\"><tr><td align=\"center\">\n";
        echo "<br>\n" . _PMSINCOME . " <b>" . $row["uname"] . "</b><br>\n<br>\n";
        echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" bgcolor=\"$bgcolor2\">\n";
        echo "<tr><td align=\"right\" width=\"10%\"><img src=\"" . $GLOBALS["url_icons"] . "/" . $row["msg_image"] . "\" border=\"0\" align=\"left\"><b>" . _PMSSUBJECT . "</b>:</td>\n<td width=\"90%\">" . msg_smile($row["subject"]) . "</td>\n</tr>\n";
        echo "<tr valign=\"top\"><td align=\"right\"><b>" . _PMSMESSAGE . "</b>:</td>\n<td bgcolor=\"$bgcolor1\"><font class=\"content\" color=\"$textcolor1\">\n" . $row["msg_text"] . "</font></td>\n</tr>\n";
        echo "<tr><td align=\"right\"><b>" . _PMSSENT . "</b>:</td>\n<td>\n<font class=\"tiny\">" . $row["msgtimestamp"] . "</font></td>\n</tr>\n";
        echo "</table>\n"; 
        // Buttons
        echo "<form name=\"act\" action=\"modules.php?name=" . $GLOBALS['module_name'] . "\" target=\"_self\" method=\"post\" style=\"border: 0px; margin-top: 5px; margin-bottom: 5px;\">";
        echo "<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS["module_name"] . "\">";
        echo "<input type=\"hidden\" name=\"file\" value=\"buddy\">";
        echo "<input type=\"hidden\" name=\"op\" value=\"compose\">";
        echo "<input type=\"hidden\" name=\"to\" value=\"" . mxEntityQuotes($row["uname"]) . "\">";
        echo "<input type=\"hidden\" name=\"subject\" value=\"" . mxEntityQuotes($replysubject) . "\">";
        echo "" . _PMSDELETE . " <input type=\"checkbox\" name=\"deletemsg\" value=\"1\" " . $delcheck . " style=\"background-color: transparent;\"> ";
        echo "<input type=\"submit\" name=\"replymsg\" value=\"" . _PMSREPLY . "\"> ";
        echo "<input type=\"submit\" name=\"closewin\" value=\"" . _PMSCLOSE . "\"> ";
        echo "<input type=\"hidden\" name=\"msg_id\" value=\"" . (int)$msg_id . "\">";
        echo "</form>\n";
        echo "</td>\n</tr>\n</table>\n";
        create_footerforall();
    } 
} 
// ##############################################
function checkmsg()
{
    global $prefix;
    if (!MX_IS_USER) return;
    $left = 390;
    $top = 150;
    $qry = "SELECT msg_id, from_userid FROM ${prefix}_priv_msgs WHERE (to_userid='" . intval($GLOBALS["userinfo"]["uid"]) . "') AND (read_msg='0');";
    $result = sql_query($qry);
    while (list($msg_id, $from_userid) = sql_fetch_row($result)) {
        if (empty($from_userid)) { // fehlerhaft gesendete Messages loeschen
            $qry = "DELETE FROM ${prefix}_priv_msgs WHERE (from_userid is null or from_userid <=1);";
            sql_query($qry);
        } 
        if (!empty($msg_id)) {
            echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!-- \n";
            echo "\n	window.open('modules.php?name=" . $GLOBALS["module_name"] . "&file=buddy&op=read&msg_id=" . $msg_id . "', '" . md5($msg_id . time()) . "', 'toolbar=0, scrollbars=1, location=0, statusbars=0, menubar=0, resizable=1, width=" . $GLOBALS['buddymsg_width'] . ", height=" . $GLOBALS['buddymsg_height'] . ", top=$top, left=$left');\n\n";
            echo "\n// -->\n</SCRIPT>\n";
            $left = $left + 20;
            $top = $top + 20;
        } 
    } 
} 
// ##############################################
function onlycheckmsg($refreshtime)
{
    if (!MX_IS_USER) return;
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head><title>check-pm</title>\n";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . _CHARSET . "\">\n";
    echo "<meta http-equiv=\"content-language\" content=\"" . _DOC_LANGUAGE . "\">\n";
    echo "<meta http-equiv=\"expires\" content=\"0\">\n";
    echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
    if ($refreshtime > 0) {
        pmSetOnline();
        create_refreshJS($refreshtime);
    } 
    checkmsg();
    echo "</head>\n<body></body>\n</html>";
} 
// ##############################################
function create_composeJS()
{
    echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!-- \n
function prvmsgto(IM) { 
window.open('modules.php?name=" . $GLOBALS["module_name"] . "&file=buddy&op=compose&to='+IM, '" . md5(time() . "compo") . "','left=370,top=150,width=" . $GLOBALS['buddymsg_width'] . ",height=" . $GLOBALS['buddymsg_height'] . ",toolbar=no,location=no,menubar=no,scrollbars=yes,resizable=yes,status=no');
}
// -->\n</script>\n";
} 
// ##############################################
function buddy($mode = "online")
{
    global $bgcolor1, $bgcolor2, $textcolor1, $textcolor2, $prefix, $user_prefix;
    $filebuddyfoot = "modules.php?name=" . $GLOBALS["module_name"] . "&amp;file=buddy&amp;op=check&amp;ref_intervall=" . $GLOBALS["buddycheckpm"] . "";
    if ($mode == "online") {
        $img = "<img src=\"" . $GLOBALS["url_images"] . "/guy_hand.gif\" width=\"19\" height=\"19\" border=\"0\" alt=\"" . _PMSNOWON . "\" align=\"middle\" style=\"background-color: transparent;\">\n<img src=\"" . $GLOBALS["url_images"] . "/girl_hand.gif\" width=\"19\" height=\"19\" border=\"0\" alt=\"" . _PMSNOWON . "\" align=\"middle\" style=\"background-color: transparent;\">";
        $linking = "<b>" . _PMSNOWON . "</b></td><td nowrap align='center'>" . $img . "</td><td align=\"center\" nowrap><a href=\"modules.php?name=" . $GLOBALS["module_name"] . "&amp;file=buddy&amp;op=allusers\" target=\"_self\">" . _PMSALLUSERS . "</a>";
        $winheigth = 290;
    } else {
        $img = "<img src=\"" . $GLOBALS["url_images"] . "/people.gif\" width=\"19\" height=\"19\" border=\"0\" alt=\"" . _PMSALLUSERS . "\" align=\"middle\" style=\"background-color: transparent;\">\n";
        $linking = "<b>" . _PMSALLUSERS . "</b></td><td align='center' nowrap>" . $img . "</td><td align=\"center\" nowrap><a href=\"modules.php?name=" . $GLOBALS["module_name"] . "&amp;file=buddy&amp;op=list\" target=\"_self\">" . _PMSNOWON . "</a>";
        $winheigth = 350;
    } 
    $listing = get_userslist($mode);

    $ref = "";

    foreach($listing as $showname => $uname) {
        $newref = substr($showname, 0, 1);
        $newref = ($newref == " ") ? "Admins" : $newref;
        $link = "";
        if ($ref != $newref) {
            $ref = $newref;
            $refs[] = "<a href=\"#" . $newref . "\">" . $newref . "</a>";
            $link = " name=\"" . $newref . "\"";
        } 
        $out[] = "<li>&nbsp;<A href=\"javascript:prvmsgto('" . $uname . "')\" style=\"text-decoration : none;\"" . $link . ">" . $showname . "</a>";
    } 
    $listing = "";
    if (isset($out)) {
        $listing = implode("\n", $out);
        $ref = implode("&nbsp;\n", $refs);
    } 

    create_headerforall($GLOBALS["sitename"]);
    create_composeJS();
    create_bodyforall(); # style="width: 100%; height: 100%; overflow : auto;"
    printOverlibDiv();
    $pm_overlib = new Overlib();
    $pm_overlib->ol_width = 200;
    $pm_overlib->ol_delay = 300;
    $pm_overlib->ol_hauto = "True";
    $pm_overlib->ol_vauto = "True";
    $myover = $pm_overlib->vover(pmValueToText(_PMSDISCRIBE), "");
    $jsvar = (isset($_REQUEST['noresize'])) ? '' : '&noresize=1';
    if ($mode == "online") {

        ?>
<script language="JavaScript" type="text/javascript">
<!--
setInterval('self.location.href=self.location.href + "<?php echo $jsvar ?>"', <?php echo $GLOBALS["buddylistrefresh"] ?>);
//-->
</script>
<?php } 
    if (empty($_REQUEST['noresize'])) {

        ?>
<script language="JavaScript" type="text/javascript">
<!--
window.resizeTo(240,<?php echo $winheigth ?>);
//-->
</script>
<?php } 

    ?>
<table width="100%" border="0" cellspacing="2" cellpadding="0">
<tr>
<th colspan="3"><a name="gotop"<?php echo $myover ?>><?php echo _PMSTITLE ?></a></th>
</tr>
<tr>
<td align="center" nowrap><?php echo $linking ?></td>
</tr>
<tr>
<td height="175" colspan="3">
<div align="left" id="list" style="height: 175px; width: 100%; overflow: auto; font-size: 11px; padding-top: 2px; border-top: 1px solid <?php echo $textcolor1 ?>; ">
<ol start="1"><?php echo $listing ?></ol>
</div></td>
</tr>

<?php if ($mode != "online") {

        ?>
<tr><td colspan="3"><div align="justify" id="refs" style=" width: 100%; overflow: visible; font-size: 11px; padding-top: 8px; border-top: 1px solid <?php echo $textcolor1 ?>; text-align: justify; text-decoration: none;">
<?php echo $ref ?>
</div></td></tr>
<?php } 

    ?>
</table>
<iframe src="<?php echo $filebuddyfoot ?>" name="check" id="check" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no" frameborder="0" style="visibility: hidden;"></iframe>
<?php
    create_footerforall();
} 
// ##############################################
function closewindow()
{
    echo "<html>\n<head>\n<script type=\"text/javascript\">\n\n<!--\n\nwindow.close();\n\n//-->\n\n</script>\n</head>\n<body>\n</body>\n</html>";
    die();
} 
// ##############################################
function create_refreshJS($refreshtime)
{
    $content = "";
    if ($refreshtime > 0) {
        $content .= "<script language=\"JavaScript\" type=\"text/javascript\">\n";
        $content .= "	<!--\n";
        $content .= "	setInterval('self.location.href=self.location.href', " . $refreshtime . ")\n";
        $content .= "	//-->\n";
        $content .= "</script>\n";
    } 
    echo $content;
} 
// ##############################################
function notloggedin()
{
    create_headerforall(_PMSTITLE);
    create_bodyforall();
    echo "\n<br>\n<br>\n<br><br><center><font class=\"title\"><b>" . _PMSPLSLOGIN . "!</b></font><br><br><br>\n";
    echo "<a href=\"javascript:window.close()\" onClick='window.close()'><img src=\"" . $GLOBALS["url_button"] . "/schliessen.gif\" border=0 width=\"102\" height=\"20\" style=\"background-color: transparent;\"></a><br>\n<br>\n\n";
    create_footerforall();
    die("");
} 
// ##############################################
function notallowed()
{
    create_headerforall(_PMSTITLE);
    create_bodyforall();
    echo "\n<br>\n<br>\n<br><br><center><font class=\"title\"><b>" . _GROUPRESTRICTEDAREA . "!</b></font><br><br><br>\n";
    echo "<a href=\"javascript:window.close()\" onClick='window.close()'><img src=\"" . $GLOBALS["url_button"] . "/schliessen.gif\" border=0 width=\"102\" height=\"20\" style=\"background-color: transparent;\"></a><br>\n<br>\n\n";
    create_footerforall();
    die("");
} 
// ########### mainprog #######################################
if (empty($op)) $op = "buddy";
if (empty($ref_intervall)) {
    $ref_intervall = 0;
} 
if (empty($subject)) $subject = "";
// mxdebugfuncvars($_POST);
switch ($op) {
    case "read":
        readm($msg_id);
        break;
    case "send":
        sendm($to, $to_userid, $message, $subject);
        break;
    case "compose":
        if (isset($deletemsg) && isset($msg_id)) {
            $result = sql_query("delete FROM ${prefix}_priv_msgs WHERE (to_userid='" . intval($GLOBALS["userinfo"]["uid"]) . "') AND (msg_id=" . intval($msg_id) . ") or (from_userid is null)");
        } 
        if (isset($closewin)) {
            closewindow();
            die();
        } else {
            compose($to, $subject);
        } 
        break;
    case "check":
        onlycheckmsg($ref_intervall);
        break;
    case "allusers":
        buddy("all");
        break;
    case "list":
        buddy();
        break;
    case "buddy":
        buddy();
        break;
    default:
        buddy();
        break;
} 
